# Yobiengine

Framework for stateful oop combining class based programming with statechart principles

## Principles

- Transition has a trigger: event, condition, idle timeout and delay.
- A composite state is used to encapsulate states with the same events. Fewer arrows.
- History state can only be in a composite state.
- Shallow history state: Remembers the state in the same level.
- Deep history state: Remembers the state that can be very deep in the hierarchy.
- A composite state can transition to a sibling state no matter which substate is active. Use deep history state to remember what substate to enter when the composite state is entered again.
- Final state: terminates the statechart. Could be multiple final states. They have no outgoing transitions.

## Tutorials

- http://publib.boulder.ibm.com/infocenter/rsmhelp/v7r5m0/index.jsp?topic=%2Fcom.ibm.xtools.modeler.doc%2Ftopics%2Ftwrksmd.html
- http://jcsites.juniata.edu/faculty/rhodes/smui/statechart.htm
- http://www.lkn.ei.tum.de/arbeiten/faq/man/tau_uml_45_doc/doc/user/mg/dgmsuml7.html
- http://www.xjtek.com/files/book/Designing_state-based_behavior-statecharts.pdf
- http://www.inf.ed.ac.uk/teaching/courses/seoc/2007_2008/notes/LectureNote12_slides.pdf
- http://www3.informatik.uni-erlangen.de/Lectures/UMLEmbSys/WS2001/slides/Statecharts.pdf
- http://www.agilemodeling.com/artifacts/stateMachineDiagram.htm
- http://santos.cis.ksu.edu/771-Distribution/Reading/uml-section3.73-94.pdf
- http://www.tutorialspoint.com/uml/uml_statechart_diagram.htm
- http://www.developer.com/design/article.php/2238131/State-Diagram-in-UML.htm
- http://www.slideshare.net/erant/uml-statechart-diagrams
- http://www.uml.org.cn/UMLApplication/pdf/bestbook.pdf
- http://www.boost.org/doc/libs/1_41_0/libs/statechart/doc/tutorial.html
